#include "MainWindow.hpp"
#include "DetailWindow.hpp"
#include "RSSReader.hpp"
#include "SoftkeyWindow.hpp"

#define SUBSURIPTION_MARGIN 30

DetailWindow::DetailWindow(SInt16 cursor) :
    SFRTitleWindow(SFRApplication::GetInstance(),
        SFXGraphics::GetDeviceRectangle().SubBottom(SoftkeyWindow::GetInstance()->GetHeight()),
        SFXAnsiString::EmptyInstance()),
    _displine(0), _cursor(0) static_throws
{
    // `nho^
    if (static_try()) {
        static_throw(
            RegisterHandler(
                SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT, HANDLER_BEFORE,
                HANDLER_FUNCTION(OnRenderContent)));
    }
     // L[nho^
    if (static_try()) {
        static_throw(
            RegisterHandler(
                SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
    }
    // \svZ
    _maxline = GetContentWorld().GetHeight()
        / SFXGraphics::GetFontHeight(AEE_FONT_NORMAL) / 2;
    SetSoftkey();

    _cursor=cursor;
    _moveY = 0;
    UpdateTitle();


    return;
}

Void DetailWindow::SetSoftkey()
{
    SoftkeyWindow::GetInstance()->Set("Ǒ", "߂", "̌");
    return;
}



Void DetailWindow::UpdateTitle(Void)
{
    RSSFeedPtr current;
    current = rssreader::GetCurrentFeed();
    SFXAnsiString dTitle;
    dTitle = current->GetItem(_cursor)->title;
    SFRTitleWindow::SetTitle(dTitle);
    InvalidateBase();
    InvalidateContent();
}


HANDLER_IMPLEMENT_VOIDRENDER(DetailWindow, OnRenderContent, graphics)
{
    //ʃTCY擾
    SFXRectangle rectangle(GetContentWorld());
    SFXRGBColor forecolor;
    SFXRGBColor backcolor;
    RSSFeedPtr current;

    // tHg̍擾
    SInt16 height = graphics->GetFontHeight();

    // ̒`̒ӂoĂ
    SInt16 bottom = rectangle.GetBottom();

    // rectangle ̍tHg̍ɐݒ
    rectangle.SetHeight(height);

    SFRTitleWindow::ContentHandler(graphics);
    current = rssreader::GetCurrentFeed();

    rectangle.SetHeight(((bottom - rectangle.GetTop()) / height) * height);
    graphics->FillRectangle(rectangle, SFXRGBColor(255, 255, 255, 0));

    graphics->SetForeColor(SFXRGBColor(0, 0, 0, 0));
    if (current != null &&
            current->GetSize() > _displine + _cursor) {
        _currentRect = rectangle;
        if(_currentRect.GetY() >= rectangle.GetY())
        {
            _currentRect.SubY(_moveY);
        }
        _currentRect.AddHeight(500);

        // J[\ŎwACe̋Lq`悷
        graphics->DrawMultipleTextLeft(
            current->GetItem(_displine + _cursor)->description,
            _currentRect,
            _currentRect.GetOrigin(),
            _currentRect.GetWidth());
    }
return;
}



HANDLER_IMPLEMENT_BOOLEVENT(DetailWindow, OnKey, event)
{
    SFXRectangle rectangle;
    switch (event.GetP16()) {

        //XN[F
        case AVK_8:     case AVK_DOWN:
            _moveY = _moveY + 5;
            InvalidateContent();
            return true;

        //XN[F
        case AVK_2:     case AVK_UP:
            if(_moveY > 0)
            {
                _moveY = _moveY - 5;
                InvalidateContent();
            }
            return true;

        //t\
        case AVK_5:     case AVK_CLR:
            Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
            MainWindow::SetSoftkey();
        return true;

        // J[\ԉɂȂ
        case AVK_RIGHT:         case AVK_SOFT2:
            if (_cursor == _maxline - 1) {
                ++_displine;
                InvalidateContent();
            } else {
                ++_cursor;
                InvalidateContent();
            }
            _moveY = 0;
            UpdateTitle();
            return true;

        // J[\ԏɂȂ
        case AVK_LEFT:      case AVK_SOFT1:
            if (_cursor == 0) {
                if (_displine > 0) {
                    --_displine;
                    InvalidateContent();
                }
            } else {
                --_cursor;
                InvalidateContent();
            }
            _moveY = 0;
            UpdateTitle();
            return true;
        }
    return false;
}
