#include "MainWindow.hpp"
#include "RSSReader.hpp"
#include "SubscriptionWindow.hpp"
#include "SoftkeyWindow.hpp"
#include "DetailWindow.hpp"

#define SUBSURIPTION_MARGIN 30

MainWindow::MainWindow(SInt16 softkeyHeight) :
    SFRTitleWindow(SFRApplication::GetInstance(),
        SFXGraphics::GetDeviceRectangle().SubBottom(softkeyHeight),
        SFXAnsiString::EmptyInstance()),
    _displine(0), _cursor(0) static_throws
{
    // Gnho^
    if (static_try()) {
        static_throw(
            RegisterHandler(
                SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT, HANDLER_BEFORE,
                HANDLER_FUNCTION(OnRenderContent)));
    }

     // L[nho^
    if (static_try()) {
        static_throw(
            RegisterHandler(
                SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
    }
    // \svZ
    _maxline = GetContentWorld().GetHeight()
        / SFXGraphics::GetFontHeight(AEE_FONT_NORMAL) / 2;
    SetSoftkey();

    _moveX = 0;
    _moveY = 0;
    return;
}

Void MainWindow::SetSoftkey()
{
    SoftkeyWindow::GetInstance()->Set("I", "I", "ꗗ");
    return;
}

HANDLER_IMPLEMENT_VOIDRENDER(MainWindow, OnRenderContent, graphics)
{
    //ʃTCY擾
    SFXRectangle rectangle(GetContentWorld());
    SFXRGBColor forecolor;
    SFXRGBColor backcolor;
    SIntN i;
    RSSFeedPtr current;

    // tHg̍擾
    SInt16 height = graphics->GetFontHeight();
    SInt16 bottom = rectangle.GetBottom();
    // rectangle ̍tHg̍ɐݒ
    rectangle.SetHeight(height);
    SFRTitleWindow::ContentHandler(graphics);
    current = rssreader::GetCurrentFeed();
    rectangle.AddY((6 * height + 15));
    rectangle.SetHeight(((bottom - rectangle.GetTop()) / height) * height);
    graphics->FillRectangle(rectangle, SFXRGBColor(255, 255, 255, 0));

    // ̐Fw
    graphics->SetForeColor(SFXRGBColor(0, 0, 0, 0));
    if (current != null &&
            current->GetSize() > _displine + _cursor) {
        _currentRect = rectangle;
        if(_currentRect.GetY() >= rectangle.GetY())
        {
            _currentRect.SubY(_moveY);
        }
        _currentRect.AddHeight(500);
        // J[\ŎwACe̋Lq`悷
        graphics->DrawMultipleTextLeft(
            current->GetItem(_displine + _cursor)->description,
            _currentRect,
            _currentRect.GetOrigin(),
            _currentRect.GetWidth());
    }

    rectangle.SubY((6 * height + 15));
    rectangle.SetHeight(height);

    // es̕`揈
    for (i = _displine;  i < _displine + _maxline ; ++i) {
        // J[\̂sȂ
        if (i - _displine == _cursor) {

            forecolor.Set(0xff, 0xff, 0xff, 0x00);
            backcolor.Set(0x66, 0x66, 0xff, 0x00);
        }
        else {
            forecolor.Set(0x00, 0x00, 0x00, 0x00);
            // sڂƊsڂŐFς
            if (i % 2 == 0) {
                backcolor.Set(0xdd, 0xdd, 0xff, 0);
            } else {
                backcolor.Set(0xee, 0xee, 0xff, 0);
            }
        }

        graphics->FillRectangle(rectangle, backcolor);
        graphics->SetForeColor(forecolor);
        if (current != null &&
                i < current->GetSize()) {
            if (current->GetItem(i)->title.IsEmpty()) {
                //iԖڂitem ̃^Cg`
                graphics->DrawSingleText("[]",
                    rectangle,
                    IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
            } else {


                    if (i - _displine == _cursor) {
                    _currentRect = rectangle;
                    _currentRect.SubX(_moveX);
                    _currentRect.AddWidth(150);
                    if (current->GetItem(i)->alreadyRead) {
                        // ACe̓e`悷
                        graphics->DrawSingleText(
                            current->GetItem(i)->title,
                            _currentRect,
                            IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
                    } else {
                        // tHgFw
                        SFXRGBColor fontColor(0x99, 0x00, 0x00, 0x00);
                        graphics->SetFont(AEE_FONT_BOLD);
                        // ACẽ^Cg`悷
                        graphics->DrawSingleText(
                            current->GetItem(i)->title,
                            _currentRect, fontColor,
                            IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
                        graphics->SetFont(AEE_FONT_NORMAL);
                    }
                }
                    else{
                if (current->GetItem(i)->alreadyRead) {
                    //iԖڂitem ̃^Cg`
                    graphics->DrawSingleText(
                        current->GetItem(i)->title,
                        rectangle,
                        IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
                } else {

                    SFXRGBColor fontColor(0x99, 0x00, 0x00, 0x00);
                    // ɂ
                    graphics->SetFont(AEE_FONT_BOLD);
                    graphics->DrawSingleText(
                        current->GetItem(i)->title,
                        rectangle,fontColor,
                        IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
                    graphics->SetFont(AEE_FONT_NORMAL);
                    }
                }
            }
        }
        // rectangleheightɈړ
        rectangle.AddY(height);
    }
    rectangle.SubY(3);
    rectangle.Deflate(0,3);
    graphics->FillRectangle(rectangle, SFXRGBColor(128, 128, 128, 255));
    return;
}

HANDLER_IMPLEMENT_BOOLEVENT(MainWindow, OnKey, event)
{
    SFXRectangle rectangle;
    RSSFeedPtr current;

    switch (event.GetP16()) {
        // L[
        case AVK_DOWN:
            // J[\ԉɂȂ
            if (_cursor == _maxline - 1) {
                ++_displine;
                InvalidateContent();
            } else {
                _cursor++;
                InvalidateContent();
            }
            _moveX = 0;
            _moveY = 0;
            return true;

        // L[
        case AVK_UP:
            // J[\ԏɂȂ
            if (_cursor == 0) {
                if (_displine > 0) {
                    --_displine;
                    InvalidateContent();
                }
            } else {
               _cursor--;
                InvalidateContent();
            }
            _moveX = 0;
            _moveY = 0;
            return true;

        // EL[FE֐XN[
        case AVK_RIGHT:
            _moveX = _moveX + 5;
            InvalidateContent();
            return true;

        // L[F֐XN[
        case AVK_LEFT:
            if(_moveX > 0)
            {
                _moveX = _moveX - 5;
                InvalidateContent();
            }
            return true;

        // 8L[F֐XN[
        case AVK_8:
            _moveY = _moveY + 5;
            InvalidateContent();
            return true;

        // 2L[F֐XN[
        case AVK_2:
            if(_moveY > 0)
            {
                _moveY = _moveY - 5;
                InvalidateContent();
            }
            return true;

        // 5L[Ft\
        case AVK_5:
            RSSFeedPtr current_item;
            current_item = rssreader::GetCurrentFeed();
            if (current_item != null && current_item->GetSize() > _displine + _cursor){
            ::new DetailWindow(_cursor);
            }
            return true;

        // Soft2 L[A9L[FtB[hǗEBhEo
        case AVK_SOFT2: case AVK_9:
            rectangle.Set(GetBaseBound());
            rectangle.AddLeftTop(SUBSURIPTION_MARGIN, SUBSURIPTION_MARGIN);
            ::new SubscriptionWindow(rectangle);
            return true;

        // IL[Fǂ̃ACeǂɂ
        case AVK_SELECT:
            current = rssreader::GetCurrentFeed();
            if (current != null &&
                    current->GetSize() > _displine + _cursor) {
                current->GetItem(_displine + _cursor)->alreadyRead = true;
                InvalidateContent();
            }
            return true;
        }
    return false;
}
