#ifndef __RSSDATA_HPP
#define __RSSDATA_HPP

#include <SophiaFramework.hpp>

#define DELIMITER_STR "<>"
#define DELIMITER_LEN 2

#define DIRECTORY_NAME "/data/"
#define DIRECTORY_PATH (SFXPath(DIRECTORY_NAME))
#define LIST_FILE_NAME "list.txt"

// RSS ̃ACe1\
SFMTYPEDEFSTRUCT(RSSItem)
struct RSSItem {
    SFXAnsiString title;
    SFXAnsiString description;
    // tSFXDate`Ŋi[
    SFXDate date;
    // ǂǂ\tOBtrue : 
    Bool alreadyRead;

    RSSItem(SFXAnsiStringConstRef rsstitle,
        SFXAnsiStringConstRef rssdescription,
        SFXDateConstRef rssdate,
        Bool rssalreadyRead = false);
};

// 1 RSS tB[h\
SFMTYPEDEFCLASS(RSSFeed)
class RSSFeed {
public:
    // TCg̃^Cg
    SFXAnsiString _title;
    // TCg URL
    SFXAnsiString _url;
    //ŏIXV
    SFXDate _date;
private:
    // RSS ۑt@C
    SFXAnsiString _filename;
    //  RSS ACeۑ
    SFXList<RSSItemPtr> _itemList;

public:
    RSSFeed(SFXAnsiStringConstRef title,
    SFXAnsiStringConstRef url, SFXDateConstRef date = SFXDate());
    ~RSSFeed(Void);
    SFCError Parse(SFXAnsiStringConstRef xml);
    SFCError SaveToFile(Void);
    Void LoadFromFile(Void);
    Bool Find(RSSItemConstRef item);
    RSSItemPtr GetItem(SInt32 index) { return _itemList.Get(index); }
    SFXAnsiStringConstRef GetFilename(Void) { return _filename; }
    Void SetFilename(SFXAnsiStringConstRef filename) { _filename = filename; }
    SInt32 GetSize(Void) { return _itemList.GetSize(); }

    friend class RSSFeedList;
};

//  RSS tB[hi[AǗ邽߂̃NX
SFMTYPEDEFCLASS(RSSFeedList)
class RSSFeedList {
private:
    //  RSS tB[hۑ
    SFXArray<RSSFeedPtr> _feedArray;

public:
    ~RSSFeedList(Void);
    Bool Add(RSSFeedPtr feed);
    SFCError SaveToFile(Void);
    Void LoadFromFile(Void);
    SInt32 GetSize(Void) { return _feedArray.GetSize(); }
    SInt32 FirstIndexOf(RSSFeedPtr item) { return _feedArray.FirstIndexOf(item); }
    RSSFeedPtr operator[](SInt32 index) { return _feedArray[index]; }
};

#endif //__RSSDATA_HPP
