#include "SoftkeyWindow.hpp"

#define SOFTKEY_MARGIN 2

SoftkeyWindow::SoftkeyWindow(Void) : SFRPlainWindow(
    SFRApplication::GetInstance(),
    SFXGraphics::GetDeviceRectangle().SetTop(
        SFXGraphics::GetDeviceRectangle().GetBottom() - GetHeight()),
    BEHAVIOR_SFRPLAINWINDOW, ATTRIBUTE_SOFTKEY) static_throws
{
    // `nho^
    if (static_try()) {
        static_throw(
            RegisterHandler(
                SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT, HANDLER_BEFORE,
                HANDLER_FUNCTION(OnRenderContent)));
    }
    return;
}

// \tgL[̃CX^X擾
SoftkeyWindowPtr SoftkeyWindow::GetInstance(Void)
{
    return static_cast<SoftkeyWindowPtr>(SFRApplication::GetInstance()
        ->GetFront(TYPE_SFRWINDOW, ATTRIBUTE_SOFTKEY, BEHAVIOR_NONE));
}

// \tgL[̍擾
SInt16 SoftkeyWindow::GetHeight(Void)
{
    return SFXGraphics::GetFontHeight(AEE_FONT_NORMAL) + SOFTKEY_MARGIN;
}

// ݒ
Void SoftkeyWindow::Set(SFXAnsiStringConstRef left,
    SFXAnsiStringConstRef center, SFXAnsiStringConstRef right)
{
    _left = left;
    _center = center;
    _right = right;
    // ĕ`
    InvalidateContent();
    return;
}

// \tgL[̕`nh
HANDLER_IMPLEMENT_VOIDRENDER(SoftkeyWindow, OnRenderContent, graphics)
{
    SFXRectangle rectangle(GetContentWorld());
    SInt16 width = rectangle.GetRight();
    // F萔
    static SFXRGBColor::AtomRecConst black = {0x00, 0x00, 0x00, 0x00};
    static SFXRGBColor::AtomRecConst inner = {0x00, 0xdd, 0xdd, 0xff};
    static SFXRGBColor::AtomRecConst outer = {0x00, 0xee, 0xee, 0xff};

    // Og
    graphics->FillRectangle(rectangle, outer);
    rectangle.DivRight(3);
    rectangle.Deflate(1, 1);
    // g
    graphics->FillRectangle(rectangle, inner);
    // ̕
    if (!_left.IsEmptyCString()) {
        graphics->DrawSingleText(_left, rectangle, black, IDF_ALIGN_CENTER);
    }
    rectangle.SetX(width / 3 + 1);
    graphics->FillRectangle(rectangle, inner);
    // ̕
    if (!_center.IsEmptyCString()) {
        graphics->DrawSingleText(_center, rectangle, black, IDF_ALIGN_CENTER);
    }
    rectangle.SetX(width * 2 / 3 + 1);
    graphics->FillRectangle(rectangle, inner);
    // E̕
    if (!_right.IsEmptyCString()) {
        graphics->DrawSingleText(_right, rectangle, black, IDF_ALIGN_CENTER);
    }
    return;
}
